/* sfg8d.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

doublereal sfg8d_c(doublereal *x, integer *ierr)
{
    /* Initialized data */

    static doublereal zero = 0.;
    static doublereal one = 1.;
    static doublereal ten = 10.;
    static doublereal r1 = .008333333333333333;
    static doublereal r2 = .08333333333333333;
    static doublereal sys001 = 3.1415932653589793;
    static doublereal sys039 = .5772156649015329;
    static doublereal sys053 = 1.7e308;

    /* System generated locals */
    doublereal ret_val;

    /* Builtin functions */
    double cos(doublereal), sin(doublereal), log(doublereal);

    /* Local variables */
    static doublereal y, x1;
    static integer ix;
    static doublereal psi;

    *ierr = 0;
    x1 = *x;
    ix = (integer) (*x);
    psi = zero;
    if (*x != zero) {
        goto L10;
    }
    psi = -sys039;
    goto L50;
L10:
    if (*x > -one) {
        goto L30;
    }
    if ((doublereal) ix != *x) {
        goto L20;
    }
    *ierr = 65;
    psi = sys053;
    goto L50;
L20:
    *x = -(*x) - one;
    psi = sys001 * cos(sys001 * *x) / sin(sys001 * *x);
L30:
    if (*x >= ten) {
        goto L40;
    }
    *x += one;
    psi -= one / *x;
    goto L30;
L40:
    y = one / (*x * *x);
    psi = psi + log(*x) + .5 / *x - ((y / 252. - r1) * y + r2) * y;
L50:
    *x = x1;
    ret_val = psi;
    return ret_val;
} /* sfg8d_c */
